%% by Pavlo Bazilinskyy <p.bazilinskyy@tudelft.nl>, Joost de Winter <j.c.f.dewinter@tudelft.nl>
clear variables;close all;clc

% *** English speaking countries ***
% Antigua and Barbuda
% Australia
% The Bahamas
% Barbados
% Belize
% Canada
% Dominica
% Grenada
% Guyana
% Ireland
% Jamaica
% New Zealand
% St Kitts and Nevis
% St Lucia
% St Vincent and the Grenadines
% Trinidad and Tobago
% United Kingdom
% United States of America
English={'ATG','AUS','BHS','BRB','BLZ','CAN','DMA','GRD','GUY','IRL','JAM','NZL','KNA','LCA','VCT','TTO','GBR','USA'};
NUMBER_CONCEPTS = 28;
FILENAME_full = 'data_s1.xlsx'; % Measurement results
[~,~,raw]=xlsread(FILENAME_full,'A2:EH1771'); %
NUMBER_PARTICIPANTS = size(raw,1);
disp(['Number of respondents = ' num2str(NUMBER_PARTICIPANTS)])
%% Basic information
temp=raw(:,16);X(:,1)=strcmp(temp,'No')+2*strcmp(temp,'Yes'); % Instructions understood
temp=raw(:,63);X(:,2)=1*strcmp(temp,'Female')+2*strcmp(temp,'Male')-1*strcmp(temp,'I prefer not to respond'); % Gender
temp=raw(:,62);for i=1:length(temp);try if strcmp(temp(i),'?');X(i,3)=NaN;else;X(i,3)= cell2mat(temp(i));end;catch error;X(i,3)=NaN;end;end % Age
X(X(:,3)>110,2)=NaN; % People who report age greater than 110 years
temp=raw(:,14);for i=1:length(temp);try if strcmp(temp(i),'?');X(i,4)=NaN;else;X(i,4)= cell2mat(temp(i));end;catch error;X(i,4)=NaN;end;end % Age of obtaining driver's license
X(X(:,4)>110,4)=NaN; % People who report licence more than 110 years
temp=raw(:,64);X(:,5)=1*strcmp(temp,'Private vehicle')+2*strcmp(temp,'Public transportation')+3*strcmp(temp,'Motorcycle')+4*strcmp(temp,'Walking/Cycling')+5*strcmp(temp,'Other')-1*strcmp(temp,'I prefer not to respond');  % Primary mode of transportation
temp=raw(:,32);X(:,6)=1*strcmp(temp,'Never')+2*strcmp(temp,'Less than once a month')+3*strcmp(temp,'Once a month to once a week')+4*strcmp(temp,'1 to 3 days a week')+5*strcmp(temp,'4 to 6 days a week')+6*strcmp(temp,'Every day')-1*strcmp(temp,'I prefer not to respond'); % How many times in past 12 months did you drive a vehicle
temp=raw(:,13);for i=1:length(temp);try X(i,7)=1+cell2mat(temp(i));catch error;X(i,7)=1*strcmp(temp(i),'0 km / mi')+2*strcmp(temp(i),'1 - 1,000 km (1 - 621 mi)')+3*strcmp(temp(i),'1,001 - 5,000 km (622 - 3,107 mi)')+4*strcmp(temp(i),'5,001 - 15,000 km (3,108 - 9,321 mi)')+5*strcmp(temp(i),'15,001 - 20,000 km (9,322 - 12,427 mi)')+6*strcmp(temp(i),'20,001 - 25,000 km (12,428 - 15,534 mi)')+7*strcmp(temp(i),'25,001 - 35,000 km (15,535 - 21,748 mi)')+8*strcmp(temp(i),'35,001 - 50,000 km (21,749 - 31,069 mi)')+9*strcmp(temp(i),'50,001 - 100,000 km (31,070 - 62,137 mi)')+10*strcmp(temp(i),'More than 100,000 km (more than 62,137 mi)')-1*strcmp(temp(i),'I prefer not to respond');end;end % Mileage
temp=raw(:,17);for i=1:length(temp);try X(i,8)=1+cell2mat(temp(i));catch error;X(i,8)=7*strcmp(temp(i),'More than 5')-1*strcmp(temp(i),'I prefer not to respond');end;end % Number of accidents
temp=raw(:,9);Country=cell(size(X,1),1);for i=1:length(temp);try Country(i)=unique(temp(i));catch error;Country(i)={'NaN'};end;end % Country
% Driving behaviour DBQ
temp=raw(:,18:24);X(:,9:15)=1*strcmp(temp,'0 times per month')+2*strcmp(temp,'1 to 3 times per month')+3*strcmp(temp,'4 to 6 times per month')+4*strcmp(temp,'7 to 9 times per month')+5*strcmp(temp,'10 or more times per month')-1*strcmp(temp,'I prefer not to respond'); % DBQ violations
% Trust questions
temp=raw(:,93);X(:,17)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % when_i_start_using_a_new_device_i_usually_need_some_time_to_learn_how_it_works
temp=raw(:,94);X(:,18)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % when_i_use_a_new_device_for_the_first_time_i_usually_read_the_manual_before_using_it
temp=raw(:,27);X(:,19)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % i_would_trust_a_car_that_drives_automatically

temp=raw(:,26);X(:,20)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % i_usually_trust_machines_until_there_is_a_reason_not_to
temp=raw(:,15);X(:,21)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % for_the_most_part_i_distrust_machines
temp=raw(:,28);X(:,22)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % in_general_i_would_rely_on_a_machine_to_assist_me
temp=raw(:,31);X(:,23)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % my_tendency_to_trust_machines_is_high
temp=raw(:,30);X(:,24)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % it_is_easy_for_me_to_trust_machines_to_do_their_job
temp=raw(:,25);X(:,25)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % i_am_likely_to_trust_a_machine_even_when_i_have_little_knowledge_about_it
%% Questions on instructions in concepts
% Mapping of concepts
% 1.  X27 6. Zebra-1
% 2.  X28 7. Zebra-2
% 3.  X29 2. Stop-1
% 4.  X30 8. Zebra-3
% 5.  X31 1. After you

% 6.  X32 23. Light strip-Stopping-After you
% 7.  X33 10. Door opening
% 8.  X34 11. Forward motion
% 9.  X35 12. Backward motion
% 10. X36 9. Do not walk symbol

% 11. X37 3. Stop-2
% 12. X38 18. Safe to cross
% 13. X39 24. Smile-1
% 14. X40 25. Smile-2
% 15. X41 4. Car slows down

% 16. X42 17. Go ahead
% 17. X43 28. Go ahead and eyes
% 18. X44 14. Light bar-1
% 19. X45 15. Light bar-2
% 20. X46 16. Light bar-3

% 21. X47 drive-ai2   22. Waiting for you to cross
% 22. X48 JLR         26. Eyes and lights-1
% 23. X49 JLR         27. Eyes and lights-2
% 24. X50 BMW         5. Light strip-1
% 25. X51 Volvo       13. Light strip-2
% 26. X52 Toyota      20. Turning left
% 27. X53 Uber        19. Please proceed to cross
% 28. X54 Uber        21. Changing lanes

% 1
temp=raw(:,44);X(:,27)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,54);X(:,28)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,55);X(:,29)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,56);X(:,30)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,57);X(:,31)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,58);X(:,32)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,59);X(:,33)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,60);X(:,34)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,61);X(:,35)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');

% 10
temp=raw(:,34);X(:,36)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,35);X(:,37)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,36);X(:,38)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,37);X(:,39)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,38);X(:,40)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,39);X(:,41)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,40);X(:,42)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,41);X(:,43)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,42);X(:,44)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,43);X(:,45)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');

% 20
temp=raw(:,45);X(:,46)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,46);X(:,47)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,47);X(:,48)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,48);X(:,49)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,49);X(:,50)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,50);X(:,51)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,51);X(:,52)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,52);X(:,53)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,53);X(:,54)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
%% Textual responses on the meaning of concepts
V=[75 85 86 87 88 89 90 91 92 65 66 67 68 69 70 71 72 73 74 76 77 78 79 80 81 82 83 84];
Y(:,1:28)=raw(:,V); % textual opinions
V2=[97 108 118 119 120 121 122 123 124 98:107 109:117];
concepts(:,1:28)=raw(:,V2); % http links

URLs={'<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept1-1.jpg" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept1-2.jpg" />'
    '<iframe src="https://www.youtube.com/embed/5oBGVIcGylw?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<iframe src="https://www.youtube.com/embed/IunP-9a0i2Q?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept2-1.jpg" />'
    '<iframe src="https://www.youtube.com/embed/lKwoEmz-m34?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept3-1.jpg" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept3-2.jpg" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept3-3.jpg" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept4-1.jpg" />' % 10
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept4-2.jpg" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept5-1.jpg" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept6-1.png" />'
    '<iframe src="https://www.youtube.com/embed/N04OkiyYChs?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<iframe src="https://www.youtube.com/embed/4oFh2cdPOug?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept8-1.jpg" />'
    '<iframe src="https://www.youtube.com/embed/2wyLPGdcJDI?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<iframe src="https://www.youtube.com/embed/qPyGLtqcL_Q?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<iframe src="https://www.youtube.com/embed/olLgcFc8Z-0?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<iframe src="https://www.youtube.com/embed/WyJ3IXgMFI0?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept10-1.png" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept12-1.jpg" />'
    '<iframe src="https://www.youtube.com/embed/zRGBvjMewLs?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<iframe src="https://www.youtube.com/embed/OCt-jpmCqCM?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<iframe src="https://www.youtube.com/embed/gSpEqpiQPP0?html5=1&mute=1" height="400" frameborder="0" align="middle"></iframe>'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept15-1.jpg" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept16-1.png" />'
    '<img src="https://bazilinskyy-research.000webhostapp.com/v2p-interaction/concept16-2.png" />'};

% Find which concepts are in the shuffled list
mappedConcepts = NaN(NUMBER_PARTICIPANTS, NUMBER_CONCEPTS);
for i=1:NUMBER_PARTICIPANTS % loop through participants
    for j=1:NUMBER_CONCEPTS % loop through concepts
        mappedConcepts(i,j)=find(strcmp(concepts(i,j),URLs));
    end
end
%% Map opinion on concepts
mappedConceptsOpinion = zeros(NUMBER_PARTICIPANTS,NUMBER_CONCEPTS);
mappedConceptsMeaning = strings(NUMBER_PARTICIPANTS,NUMBER_CONCEPTS);
for i=1:NUMBER_PARTICIPANTS % loop through participants
    for j=1:NUMBER_CONCEPTS % loop through concepts
        conceptMapped = mappedConcepts(i,j);
        mappedConceptsOpinion(i,conceptMapped)=X(i,j+26); % numeric answers
        mappedConceptsMeaning(i,conceptMapped)=Y{i,j};    % textual opinions
    end
end
% Copy mapped answers to sets with data
X(:,27:54) = mappedConceptsOpinion;
Y = mappedConceptsMeaning;
%% Year automated cars will be released
temp=raw(:,29);for i=1:length(temp);try if strcmp(temp(i),'?'); X(i,55)=NaN;else;X(i,55)=cell2mat(temp(i));end;catch error;X(i,55)=NaN;end;end % Parse answers
%% Add Survey completion time
temp1=raw(:,2);temp2=raw(:,4);for i=1:length(temp1);try X(i,57)=24*3600*(datenum(temp1(i))-datenum(temp2(i)));catch error;X(i,57)=0;end;end % Survey time
disp(['Mean survey completion time = ' num2str(mean(X(:,57))/60)])
disp(['SD survey completion time = ' num2str(std(X(:,57))/60)])
disp(['Median survey completion time = ' num2str(median(X(:,57))/60)])
%% Check if people gave meaningful answers to the questions on the meaning of each concept
% Filter answers
invalid4=zeros(NUMBER_PARTICIPANTS,NUMBER_CONCEPTS);
invalid5=zeros(NUMBER_PARTICIPANTS,NUMBER_CONCEPTS);
for i=1:NUMBER_PARTICIPANTS % loop through participants
    for j=1:NUMBER_CONCEPTS % loop through concepts
        if isnan(strlength(Y(i,j))) || strlength(Y(i,j))<4
            invalid4(i,j)=1;
        elseif regexp(Y{i,j}, '[^\x00-\x7F]+') % string contains a non-English character (phrase not in English, gibberish)
            invalid5(i,j)=1;
        end
    end
end
%% Filtering gathered data
X(X<=0)=NaN; % Put missing values (0) or no response (-1) at NaN
invalid1 = find(X(:,1)==1); % respondents who did not read instructions
invalid2 = find(X(:,3)<18);  % respondents who indicated they are under 18 years old
invalid3 = find(sum(isnan(X(:,[2 5:15 17:25 27:45])),2)>3);  % respondents who give 'I prefer not to respond' more than 3 questions
invalid4=  find((sum(invalid4,2)+sum(invalid5,2))>3); % more than 3 invalid textual responses
invalid = unique([invalid1;invalid2;invalid3;invalid4]); % Combine invalid rows
X(:,16)=nanmean(X(:,9:15),2); % DBQ violations mean score across 7 items
for i=1:length(X(:,4)); if X(i,4)<14; X(i,4)=NaN;end;end % Filter year of obtaining license
%% Show descriptive information
disp(['Number of respondents who did not read instructions = ' num2str(length(invalid1))])
disp(['Number of respondents under 18 = ' num2str(length(invalid2))])
disp(['Number of respondents with I prefer not to respond = ' num2str(length(invalid3))])
disp(['Number of respondents with invalid text inputs = ' num2str(length(invalid4))])
disp(['Number of respondents in any of these categories = ' num2str(length(invalid))])
disp(['Number of unique countries (all) = ' num2str(length(unique(Country)))])
X(invalid,:)=[]; % Remove invalid respondents
raw(invalid,:)=[]; % Remove invalid respondents
Y(invalid,:)=[]; % Remove invalid respondents
Country_unfiltered = Country; % copy data before filtering
Country(invalid)=[]; % Remove invalid respondent
disp(['Respondents left after filtering = ' num2str(size(X,1))]);
disp(['Unique countries after filtering = ' num2str(length(unique(Country)))])
temp=find(X(:,55)<2018);
X(temp,55)=NaN;
disp(['Year automated cars will be released: answers that contained years in the past = ' num2str(length(temp))])

[test2, ~, ub] = unique(Country_unfiltered);
test2counts = histcounts(ub, 'binmethod','integers');
[B,I] = maxk(test2counts,5);
country_unique = unique(Country_unfiltered);
disp('Most common countries (before filtering) = ')
disp(country_unique(I))
disp(B)

[~, ~, ub] = unique(Country);
test2counts = histcounts(ub, 'binmethod','integers');
[B,I] = maxk(test2counts,5);
country_unique = unique(Country);
disp('Most common countries (after filtering) = ')
disp(country_unique(I))
disp(B)
%% Additional information to show
disp(['Male respondents = ' num2str(nansum(X(:,2)==2))])
disp(['Female respondents = ' num2str(nansum(X(:,2)==1))])
disp(['Mean age = ' num2str(mean(X(:,3)))])
disp(['SD age = ' num2str(std(X(:,3)))])
%% Trust score
Trust=nanzscore(nanmean(nanzscore([X(:,20) X(:,22) X(:,23) X(:,24) X(:,25) 6-X(:,21)]),2));
DBQ=nanzscore(nanmean(nanzscore([X(:,20) X(:,22) X(:,23) X(:,24) X(:,25) 6-X(:,21)]),2));
X(:,26) = Trust;
%% Figure 1. Mean eHMI clarity scores of the instructions of the concepts.
figure;hold on;box on
[~,b]=sort(nanmean(X(:,27:54)));
barh(1:28,nanmean(X(:,b+26))','facecolor',[.5 .5 .5]);
textSigns  = [29,31,32,38,41,42,43,47,52:54]-26;
barh((find(ismember(b,textSigns))),nanmean(X(:,b(ismember(b,textSigns))+26))','facecolor',[255 165 0]/255);
labels={'6. Zebra-1 (N-E-I)',...
    '7. Zebra-2 (N-E-I)',...
    '2. Stop-1 (N-E-V)',...
    '8. Zebra-3 (N-E-V)', ...
    '1. After you (N-X-I)',...
    '23. Light strip-Stopping-After you (N-X-V)',...
    '10. Door opening (N-A-I)',...
    '11. Forward motion (N-A-I)',...
    '12. Backward motion (N-A-I)',...
    '9. Do not walk symbol (N-E-P)',...
    '3. Stop-2 (N-E-P)',...
    '18. Safe to cross (N-E-I)' ...
    '24. Smile-1 (A-E-I)',...
    '25. Smile-2 (A-E-V)' ...
    '4. Car slows down (N-X-V)',...
    '17. Go ahead (N-E-I)',...
    '28. Go ahead and eyes (X-E-V)',...
    '14. Light bar-1 (N-U-V)',...
    '15. Light bar-2 (N-U-V)',...
    '16. Light bar-3 (N-U-V)',...
    '22. Waiting for you to cross (N-X-I)',...
    '26. Eyes and lights-1 (X-X-I)', ...
    '27. Eyes and lights-2 (X-X-V)', ...
    '5. Light strip-1 (N-E-V)', ...
    '13. Light strip-2 (N-A-V)',...
    '20. Turning left (N-A-I)', ...
    '19. Please proceed to cross (N-E-P)', ...
    '21. Changing lanes (N-A-P)'};
set(gca,'yticklabel',labels(b),'Fontsize',14,'Fontname','Arial','looseinset',[0.01 0.01 0.01 0.01],'ytick',1:28,'xlim',[2.7 4.6],'ylim',[0 29]);
xlabel('Mean (1 = Disagree strongly, 5 = Agree strongly)','Fontsize',18,'Fontname','Arial')
legend('Does not contain text','Contains text','Location','northoutside','orientation','horizontal')
for k=1:length(b) % Labels next to bars with nanmean values
    str=sprintf('%1.2f',nanmean(X(:,b(k)+26)));
    text(nanmean(X(:,b(k)+26))+0.02,k,str,'Fontsize',14,'Fontname','Arial');
end
%% Paired t-test as reported in the text
v1=X(:,27+16-1);
v2=X(:,27+4-1);
[~,p,~,stats]=ttest(v1,v2);  % Go-ahead vs. Zebra-3
disp(['Mean (SD) Go ahead: ' sprintf('%0.2f',nanmean(v1)) ' (' sprintf('%0.2f',nanstd(v1)) ')'])
disp(['Mean (SD) Daimler-4: ' sprintf('%0.2f',nanmean(v2)) ' (' sprintf('%0.2f',nanstd(v2)) ')'])
disp(['Paired-ramples t-test, Go Ahead vs. Daimler-4: t(' num2str(stats.df) ') = ' sprintf('%0.2f',stats.tstat) ', p = ' sprintf('%0.5f',p)])
%% Find strings among the comments
[Sensor,Scanning,Detect,Cross,Car,Pedestrian]=deal(zeros(size(X,1),NUMBER_CONCEPTS));
for i=1:NUMBER_CONCEPTS
    a=regexpi(Y(:,i),'sensor');
    for i2=1:length(a) % loop over all 1466 participants
        if cell2mat(a(i2))>0
            Sensor(i2,i)=1;
        end
    end
    a=regexpi(Y(:,i),'scanning');
    for i2=1:length(a)
        if cell2mat(a(i2))>0
            Scanning(i2,i)=1;
        end
    end
    a=regexpi(Y(:,i),'detect');
    for i2=1:length(a)
        if cell2mat(a(i2))>0
            Detect(i2,i)=1;
        end
    end
    a=regexpi(Y(:,i),'cross');
    for i2=1:length(a)
        if cell2mat(a(i2))>0
            Cross(i2,i)=1;
        end
    end
    a=regexpi(Y(:,i),'car');
    for i2=1:length(a)
        if cell2mat(a(i2))>0
            Car(i2,i)=1;
        end
    end
    a=regexpi(Y(:,i),'pedestrian');
    for i2=1:length(a)
        if cell2mat(a(i2))>0
            Pedestrian(i2,i)=1;
        end
    end
end
S=100*mean(sign(Sensor+Scanning));
disp(['Number of statements with the word ''sensor'' ' num2str(sum(sum((Sensor))))])
disp(['Number of statements with the word ''sensor'' ' num2str(sum(sum((Scanning))))])
disp(['Number of statements with the word ''detect'' ' num2str(sum(sum((Detect))))])
disp(['Number of statements with the word ''cross'' ' num2str(sum(sum((Cross))))])
disp(['Number of statements with the word ''car'' ' num2str(sum(sum((Car))))])
disp(['Number of statements with the word ''pedestrian'' ' num2str(sum(sum((Pedestrian))))])

%% Figure 2. Percentage of respondents who reported sensor or scanning when describing the concepts.
figure;hold on;box on
[~,b]=sort(S);
barh(1:28,S(b)','facecolor',[.5 .5 .5]);
barh((find(ismember(b,textSigns))),S(b(ismember(b,textSigns)))','facecolor',[255 165 0]/255);
legend('Does not contain text','Contains text','Location','northoutside','orientation','horizontal')
xlabel('Percentage of participants mentioning ''sensor'' or ''scanning''','Fontsize',18,'Fontname','Arial')
set(gca,'yticklabel',labels(b),'Fontsize',14,'Fontname','Arial','xlim',[0 9],'ylim',[0 29],'ytick',1:28,'LooseInset', [0.01 0.01 0.01 0.01])
for k=1:length(b)
    str=sprintf('%1.2f',S(b(k)));
    text(S(b(k))+.1,k,str,'Fontsize',16,'Fontname','Arial'); % Labels next to bars with nanmean values
end
%% Spearman correlation coefficients
[c,p]=corr(X(:,6),nanmean(X(:,27:54),2),'rows','pairwise','type','spearman'); % driving frequency
disp('Correlation between clarity scores and driving frequency, p-value, sample size')
disp([c p sum(~isnan(X(:,6)+nanmean(X(:,27:54),2)))]);
[c,p]=corr(X(:,7),nanmean(X(:,27:54),2),'rows','pairwise','type','spearman'); % driving mileage
disp('Correlation between clarity scores and driving mileage, p-value, sample size')
disp([c p  sum(~isnan(X(:,7)+nanmean(X(:,27:54),2)))]);
[c,p]=corr(Trust,nanmean(X(:,27:54),2),'rows','pairwise','type','spearman'); % trust
disp('Correlation between clarity scores and trust, p-value, sample size')
disp([c p  sum(~isnan(Trust+nanmean(X(:,27:54),2)))]);
[c,p]=corr(X(:,2),nanmean(X(:,27:54),2),'rows','pairwise','type','spearman'); % gender
disp('Correlation between clarity scores and gender, p-value, sample size')
disp([c p  sum(~isnan(X(:,2)+nanmean(X(:,27:54),2)))]);
[c,p]=corr(X(:,3),nanmean(X(:,27:54),2),'rows','pairwise','type','spearman'); % age
disp('Correlation between clarity scores and age, p-value, sample size')
disp([c p  sum(~isnan(X(:,3)+nanmean(X(:,27:54),2)))]);
%% Figure 3. Point-biserial correlation (r) between clarity rating and whether respondents were from an English-speaking country (1) or not (0).
figure;hold on;box on
rpb=corr(ismember(Country,English),X(:,27:54),'rows','pairwise');
ME=nanmean(X(ismember(Country,English),27:54)); % mean for English-speaking countries
MNE=nanmean(X(~ismember(Country,English),27:54)); % mean for non-English-speaking countries

[~,b]=sort(rpb);
barh(1:28,rpb(b)','facecolor',[.5 .5 .5]);
barh((find(ismember(b,textSigns))),rpb(b(ismember(b,textSigns)))','facecolor',[255 165 0]/255);
legend('Does not contain text','Contains text','Location','northoutside','orientation','horizontal')
xlabel('Point-biserial correlation between clarity ratings (1 to 5) and being from an English-speaking country (0 = no, 1 = yes)','Fontsize',18,'Fontname','Arial')
set(gca,'yticklabel',labels(b),'Fontsize',14,'Fontname','Arial','ylim',[0 29],'xlim',[-.20 .14],'xtick',-1:0.02:1,'LooseInset', [0.01 0.01 0.01 0.01],'ytick',1:28)

for k=1:length(b) % Labels next to bars with nanmean values
    str=sprintf('%1.2f',rpb(b(k)));
    str2=sprintf('%1.2f',ME(b(k)));
    str3=sprintf('%1.2f',MNE(b(k)));
    if rpb(b(k))>0
        text(rpb(b(k))+.002,k,['\it{r}\rm = ' str ' (ME: ' str2 ', MNE: ' str3 ')'],'Fontsize',14,'Fontname','Arial','horizontalalignment','left');
    elseif rpb(b(k))<0
        text(rpb(b(k))-.002,k,['\it{r}\rm = ' str ' (ME: ' str2 ', MNE: ' str3 ')'],'Fontsize',14,'Fontname','Arial','horizontalalignment','right');
    end
end
