%% by Pavlo Bazilinskyy <p.bazilinskyy@tudelft.nl>, Joost de Winter <j.c.f.dewinter@tudelft.nl>
clear variables;close all;clc
NUMBER_CONCEPTS = 15; % 15
THRESHOLD_COLOR = 3; % if participant does not specify colour of more than THRESHOLD_COLOR
FILENAME_full = 'data_s2.xlsx'; % Measurement results
[~,~,raw]=xlsread(FILENAME_full,'A2:DJ2001'); %
NUMBER_PARTICIPANTS = size(raw,1);   % 20 in pilot, 2000 in full job
disp(['Number of respondents = ' num2str(NUMBER_PARTICIPANTS)])
%% Basic information
temp=raw(:,16);X(:,1)=strcmp(temp,'No')+2*strcmp(temp,'Yes'); % Instructions understood
temp=raw(:,80);X(:,2)=1*strcmp(temp,'Female')+2*strcmp(temp,'Male')-1*strcmp(temp,'I prefer not to respond'); % Gender
temp=raw(:,79);for i=1:length(temp);try if strcmp(temp(i),'?');X(i,3)=NaN;else;X(i,3)= cell2mat(temp(i));end;catch error;X(i,3)=NaN;end;end % Age
X(X(:,3)>110,3)=NaN; % People who report age greater than 110 years
temp=raw(:,14);for i=1:length(temp);try if strcmp(temp(i),'?');X(i,4)=NaN;else;X(i,4)= cell2mat(temp(i));end;catch error;X(i,4)=NaN;end;end % Age of obtaining driver's license
X(X(:,4)>110,4)=NaN; % People who report licence more than 110 years
temp=raw(:,81);X(:,5)=1*strcmp(temp,'Private vehicle')+2*strcmp(temp,'Public transportation')+3*strcmp(temp,'Motorcycle')+4*strcmp(temp,'Walking/Cycling')+5*strcmp(temp,'Other')-1*strcmp(temp,'I prefer not to respond');  % Primary mode of transportation
temp=raw(:,32);X(:,6)=1*strcmp(temp,'Never')+2*strcmp(temp,'Less than once a month')+3*strcmp(temp,'Once a month to once a week')+4*strcmp(temp,'1 to 3 days a week')+5*strcmp(temp,'4 to 6 days a week')+6*strcmp(temp,'Every day')-1*strcmp(temp,'I prefer not to respond'); % How many times in past 12 months did you drive a vehicle
temp=raw(:,13);for i=1:length(temp);try X(i,7)=1+cell2mat(temp(i));catch error;X(i,7)=1*strcmp(temp(i),'0 km / mi')+2*strcmp(temp(i),'1 - 1,000 km (1 - 621 mi)')+3*strcmp(temp(i),'1,001 - 5,000 km (622 - 3,107 mi)')+4*strcmp(temp(i),'5,001 - 15,000 km (3,108 - 9,321 mi)')+5*strcmp(temp(i),'15,001 - 20,000 km (9,322 - 12,427 mi)')+6*strcmp(temp(i),'20,001 - 25,000 km (12,428 - 15,534 mi)')+7*strcmp(temp(i),'25,001 - 35,000 km (15,535 - 21,748 mi)')+8*strcmp(temp(i),'35,001 - 50,000 km (21,749 - 31,069 mi)')+9*strcmp(temp(i),'50,001 - 100,000 km (31,070 - 62,137 mi)')+10*strcmp(temp(i),'More than 100,000 km (more than 62,137 mi)')-1*strcmp(temp(i),'I prefer not to respond');end;end % Mileage
temp=raw(:,17);for i=1:length(temp);try X(i,8)=1+cell2mat(temp(i));catch error;X(i,8)=7*strcmp(temp(i),'More than 5')-1*strcmp(temp(i),'I prefer not to respond');end;end % Number of accidents
temp=raw(:,9);Country=cell(size(X,1),1);for i=1:length(temp);try Country(i)=unique(temp(i));catch error;Country(i)={'NaN'};end;end % Country
% Driving behaviour DBQ
temp=raw(:,18:24);X(:,9:15)=1*strcmp(temp,'0 times per month')+2*strcmp(temp,'1 to 3 times per month')+3*strcmp(temp,'4 to 6 times per month')+4*strcmp(temp,'7 to 9 times per month')+5*strcmp(temp,'10 or more times per month')-1*strcmp(temp,'I prefer not to respond'); % DBQ violations
% Trust questions
temp=raw(:,82);X(:,17)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % when_i_start_using_a_new_device_i_usually_need_some_time_to_learn_how_it_works
temp=raw(:,83);X(:,18)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % when_i_use_a_new_device_for_the_first_time_i_usually_read_the_manual_before_using_it
temp=raw(:,27);X(:,19)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % i_would_trust_a_car_that_drives_automatically

temp=raw(:,26);X(:,20)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % i_usually_trust_machines_until_there_is_a_reason_not_to
temp=raw(:,15);X(:,21)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % for_the_most_part_i_distrust_machines
temp=raw(:,28);X(:,22)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % in_general_i_would_rely_on_a_machine_to_assist_me
temp=raw(:,31);X(:,23)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % my_tendency_to_trust_machines_is_high
temp=raw(:,30);X(:,24)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % it_is_easy_for_me_to_trust_machines_to_do_their_job
temp=raw(:,25);X(:,25)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % i_am_likely_to_trust_a_machine_even_when_i_have_little_knowledge_about_it
%%%%%
X(X<0)=NaN;
%%%%%
%% Questions on instructions in concepts

temp=raw(:,52);X(:,27)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure'); % would_you_feel_safe_to_cross_in_front_of_the_car_above
temp=raw(:,55);X(:,28)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,58);X(:,29)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,61);X(:,30)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,64);X(:,31)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,67);X(:,32)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,70);X(:,33)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,73);X(:,34)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,76);X(:,35)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,34);X(:,36)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,37);X(:,37)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,40);X(:,38)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,43);X(:,39)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,46);X(:,40)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');
temp=raw(:,49);X(:,41)=1*strcmp(temp,'Yes')+2*strcmp(temp,'No')-1*strcmp(temp,'Not sure');

temp=raw(:,54);X(:,42)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure'); % what_is_the_color_of_the_textpixels_on_the_display_of_the_car_above
temp=raw(:,57);X(:,43)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,60);X(:,44)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,63);X(:,45)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,66);X(:,46)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,69);X(:,47)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,72);X(:,48)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,75);X(:,49)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,78);X(:,50)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,36);X(:,51)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,39);X(:,52)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,42);X(:,53)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,45);X(:,54)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,48);X(:,55)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');
temp=raw(:,51);X(:,56)=1*strcmp(temp,'Green')+2*strcmp(temp,'Red')+3*strcmp(temp,'White')-1*strcmp(temp,'Not sure');

Y(:,1)=raw(:,53); % if_you_think_that_the_message_on_the_car_above_is_unclear_please_explain_why
Y(:,2)=raw(:,56);
Y(:,3)=raw(:,59);
Y(:,4)=raw(:,62);
Y(:,5)=raw(:,65);
Y(:,6)=raw(:,68);
Y(:,7)=raw(:,71);
Y(:,8)=raw(:,74);
Y(:,9)=raw(:,77);
Y(:,10)=raw(:,35);
Y(:,11)=raw(:,38);
Y(:,12)=raw(:,41);
Y(:,13)=raw(:,44);
Y(:,14)=raw(:,47);
Y(:,15)=raw(:,50);
%% Map shuffled concepts
concepts(:,1) = raw(:,86);
concepts(:,2) = raw(:,93);
concepts(:,3) = raw(:,94);
concepts(:,4) = raw(:,95);
concepts(:,5) = raw(:,96);
concepts(:,6) = raw(:,97);
concepts(:,7) = raw(:,98);
concepts(:,8) = raw(:,99);
concepts(:,9) = raw(:,100);
concepts(:,10) = raw(:,87);
concepts(:,11) = raw(:,88);
concepts(:,12) = raw(:,89);
concepts(:,13) = raw(:,90);
concepts(:,14) = raw(:,91);
concepts(:,15) = raw(:,92);

% Find which concepts are in the shuffled list
mappedConcepts = zeros(NUMBER_PARTICIPANTS, NUMBER_CONCEPTS);
for i=1:NUMBER_PARTICIPANTS % loop through participants
    for j=1:NUMBER_CONCEPTS % loop through concepts
        if  strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-dont_walk-green.png" />')
            mappedConcepts(i,j) = 1;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-dont_walk-red.png" />')
            mappedConcepts(i,j) = 2;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-dont_walk-white.png" />')
            mappedConcepts(i,j) = 3;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-empty-green.png" />')
            mappedConcepts(i,j) = 4;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-empty-red.png" />')
            mappedConcepts(i,j) = 5;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-empty-white.png" />')
            mappedConcepts(i,j) = 6;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-walk-green.png" />')
            mappedConcepts(i,j) = 7;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-walk-red.png" />')
            mappedConcepts(i,j) = 8;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-walk-white.png" />')
            mappedConcepts(i,j) = 9;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-will_stop-green.png" />')
            mappedConcepts(i,j) = 10;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-will_stop-red.png" />')
            mappedConcepts(i,j) = 11;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-will_stop-white.png" />')
            mappedConcepts(i,j) = 12;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-wont_stop-green.png" />')
            mappedConcepts(i,j) = 13;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-wont_stop-red.png" />')
            mappedConcepts(i,j) = 14;
        elseif strcmp(concepts(i,j), '<img src="https://bazilinskyy-research.000webhostapp.com/ehmi-survey/Attentive_driver-wont_stop-white.png" />')
            mappedConcepts(i,j) = 15;
        else
            disp (concepts(i,j));
            mappedConcepts(i,j) = -1;
        end
    end
end

% Map opinion on concepts
mappedConceptsOpinion = zeros(NUMBER_PARTICIPANTS,NUMBER_CONCEPTS);
mappedConceptsColor = zeros(NUMBER_PARTICIPANTS,NUMBER_CONCEPTS);
mappedConceptsMeaning = strings(NUMBER_PARTICIPANTS,NUMBER_CONCEPTS);
for i=1:NUMBER_PARTICIPANTS % loop through participants
    for j=1:NUMBER_CONCEPTS % loop through concepts
        conceptMapped = mappedConcepts(i,j);
        mappedConceptsOpinion(i,conceptMapped)=X(i,j+26);
        mappedConceptsColor(i,conceptMapped)=X(i,j+41);
        mappedConceptsMeaning(i,conceptMapped)=Y{i,j};
    end
end
% Copy mapped answers to sets with data
X(:,27:41) = mappedConceptsOpinion;
X(:,42:56) = mappedConceptsColor;
Y = mappedConceptsMeaning;

% Year of automated driving
temp=raw(:,29);for i=1:length(temp);try if strcmp(temp(i),'?'); X(i,57)=NaN;else;X(i,57)=cell2mat(temp(i));end;catch error;X(i,57)=NaN;end;end % in_which_year_do_you_think_that_most_cars_will_be_able_to_drive_fully_automatically_in_your_country_of_residence

temp=find(X(:,57)<2018);X(temp,57)=NaN; % People who report a number less than 2014
disp(['Year automated cars will be released: answers that contained years in the past: ' num2str(length(temp))])
disp(['Year automated cars will be released: total number of responses: ' num2str(sum(isnan(X(:,57))))])
%% Matching colours
Z = ones(NUMBER_PARTICIPANTS, NUMBER_CONCEPTS+1);
% Check if colour matches. If not, mark corresponding cell in Z as 0.
for i=1:NUMBER_PARTICIPANTS
    if X(i,42) ~= 1 % Attentive_driver-dont_walk-green
        Z(i,1) = 0;
    end
    if X(i,43) ~= 2 % Attentive_driver-dont_walk-red
        Z(i,2) = 0;
    end
    if X(i,44) ~= 3 % Attentive_driver-dont_walk-white
        Z(i,3) = 0;
    end
    if X(i,45) ~= 1 % Attentive_driver-empty-green
        Z(i,4) = 0;
    end
    if X(i,46) ~= 2 % Attentive_driver-empty-red
        Z(i,5) = 0;
    end
    if X(i,47) ~= 3 % Attentive_driver-empty-white
        Z(i,6) = 0;
    end
    if X(i,48) ~= 1 % Attentive_driver-walk-green
        Z(i,7) = 0;
    end
    if X(i,49) ~= 2 % Attentive_driver-walk-red
        Z(i,8) = 0;
    end
    if X(i,50) ~= 3 % Attentive_driver-walk-white
        Z(i,9) = 0;
    end
    if X(i,51) ~= 1 % Attentive_driver-will_stop-green
        Z(i,10) = 0;
    end
    if X(i,52) ~= 2 % Attentive_driver-will_stop-red
        Z(i,11) = 0;
    end
    if X(i,53) ~= 3 % Attentive_driver-will_stop-white
        Z(i,12) = 0;
    end
    if X(i,54) ~= 1 % Attentive_driver-wont_stop-green
        Z(i,13) = 0;
    end
    if X(i,55) ~= 2 % Attentive_driver-wont_stop-red
        Z(i,14) = 0;
    end
    if X(i,56) ~= 3 % Attentive_driver-wont_stop-white
        Z(i,15) = 0;
    end
end
%% Survey time
try
    temp1=cell2mat(raw(:,2));temp2=cell2mat(raw(:,4));for i=1:length(temp1);try X(i,57)=24*3600*(datenum(temp1(i))-datenum(temp2(i)));catch error;X(i,57)=0;end;end
catch error
    for i=1:size(raw,1)
        X(i,57)=24*3600*(datenum(raw{i,2})-datenum(raw{i,4}));
    end
end
X(X(:,57)>3600,57)=NaN;
disp(['Survey time mean = ' num2str(mean(X(:,57)))]);
disp(['Survey time SD = ' num2str(std(X(:,57)))]);
disp(['Survey time Median = ' num2str(median(X(:,57)))]);
%% Filtering
% Remove participants that did not meet the criteria
invalid1 = find(X(:,1)==1); % respondents who did not read instructions
invalid2 = find(X(:,3)<18);  % respondents who indicated they are under 18 years old
invalid3 = find(sum(Z(:,1:15),2)<NUMBER_CONCEPTS - THRESHOLD_COLOR);  % respondents who did not specify colour correctly
invalid = unique([invalid1;invalid2;invalid3]); % Add together all invalid rows with data
X_filtered = X; % copy data before filtering
Y_filtered = Y; % copy data before filtering
Z_filtered = Z; % copy data before filtering
Country_filtered = Country; % copy data before filtering
X_filtered(invalid,:)=[]; % Remove invalid respondents
Y_filtered(invalid,:)=[]; % Remove invalid respondents
Z_filtered(invalid,:)=[]; % Remove invalid respondents
Country_filtered(invalid)=[]; % Remove invalid countries
disp(['Number of respondents who did not read instructions = ' num2str(length(invalid1))])
disp(['Number of respondents under 18 = ' num2str(length(invalid2))])
disp(['Number of respondents who did not specify colour correctly = ' num2str(length(invalid3))])
disp(['Number of respondents removed = ' num2str(length(invalid))])
disp(['Number of respondents included in the analysis:  ' num2str(size(X_filtered,1))]);
disp(['Number of countries before filtering:  ' num2str(length(unique(Country)))]);
disp(['Number of countries included in the analysis:  ' num2str(length(unique(Country_filtered)))]);
disp(['Number of numeric responses to the question In which year do you think that most cars will be able to drive fully automatically in your country of residence?  ' num2str(sum(~isnan(X_filtered(:,25))))]);
%
[~, ~, ub] = unique(Country);
test2counts = histcounts(ub, 'binmethod','integers');

[B,I] = maxk(test2counts,5);
country_unique = unique(Country);
disp('Most common countries (before filtering) = ')
disp(country_unique(I))
disp(B)

[~, ~, ub] = unique(Country_filtered);
test2counts = histcounts(ub, 'binmethod','integers');
[B,I] = maxk(test2counts,5);
country_unique = unique(Country_filtered);
disp('Most common countries (after filtering) = ')
disp(country_unique(I))
disp(B)
%% Additional information to display
disp(['Gender, male respondents = ' num2str(sum(X_filtered(:,2)==2))])
disp(['Gender, female respondents = ' num2str(sum(X_filtered(:,2)==1))])
disp(['Gender, I prefer not to respond = ' num2str(sum(isnan(X_filtered(:,2))))])
disp(['Age, mean = ' num2str(nanmean(X_filtered(:,3)))])
disp(['Age, sd = ' num2str(nanstd(X_filtered(:,3)))])
%% Figure 7. Distribution of answers to the question Would you feel safe to cross in front of the car above?.
figure;
temp=[sum(X_filtered(:,27:41)==1); sum(X_filtered(:,27:41)==2); sum(X_filtered(:,27:41)==-1)]';
temp2=[zeros(size(temp,1),1) cumsum(temp')'];
b=bar(temp, 'stacked','linewidth',2);
b(1).FaceColor=[0 195 255]/255;
b(2).FaceColor=[255 165 0]/255;
b(3).FaceColor=[200 200 200]/255;

changem(X_filtered(:,27:41),[0 0.5 1],[2 -1 1]); % 1 = Yes, 2 = No, -1 = Unsure

legend('Yes', 'No', 'Not sure','location','northoutside','orientation','horizontal')
set(gca,'xticklabel',{'DON''T WALK (green)', 'DON''T WALK (red)', 'DON''T WALK (white)', 'empty (green)', 'empty (red)', 'empty (white)', 'WALK (green)', 'WALK (red)', 'WALK (white)', 'WILL STOP (green)', 'WILL STOP (red)', 'WILL STOP (white)', 'WON''T STOP (green)', 'WON''T STOP (red)', 'WON''T STOP (white)'},'Fontsize',24,'Fontname','Arial')
xtickangle(45)
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',20)
set(gca,'LooseInset', [0.01 0.01 0.01 0.01],'xlim',[0.1 15.9]);
for i2=1:3
    for i=1:15
        text(i,(temp2(i,i2)+temp2(i,i2+1))/2,[sprintf('%0.1f',100*temp(i,i2)/temp2(i,end)) '%'],'horizontalalignment','center','fontsize',10)
    end
end
ylabel('Number of respondents')
set(gca,'xticklabel',{'DON''T WALK (green)', 'DON''T WALK (red)', 'DON''T WALK (white)', 'empty (green)', 'empty (red)', 'empty (white)', 'WALK (green)', 'WALK (red)', 'WALK (white)', 'WILL STOP (green)', 'WILL STOP (red)', 'WILL STOP (white)', 'WON''T STOP (green)', 'WON''T STOP (red)', 'WON''T STOP (white)'},'Fontsize',24,'Fontname','Arial')
xtickangle(45)
set(gca,'xlim',[0.4 15.6],'ylim',[0 temp2(end,end)],'TickDir','out','ticklength',[0.005 0.005],'LooseInset',[0.01 0.01 0.01 0.01])
h=findobj('FontName','Helvetica'); set(h,'FontSize',16,'Fontname','Arial')
%% Figure A1. Figure A1. Distribution of answers to the question Would you feel safe to cross in front of the car above? before filtering of data (left), after less strict filtering (3 wrong answers allowed, center), and very strict filtering (0 wrong answers allowed, right).
figure;
subplot(1,3,1); % before filering
b=bar([sum(X(:,27:41)==1); sum(X(:,27:41)==2); sum(X(:,27:41)==-1)]', 'stacked');
b(1).FaceColor=[0 195 255]/255;
b(2).FaceColor=[255 165 0]/255;
b(3).FaceColor=[200 200 200]/255;
legend('Yes', 'No', 'Not sure', 'Location', 'southeast')
set(gca,'xticklabel',{'DON''T WALK (green)', 'DON''T WALK (red)', 'DON''T WALK (white)', 'empty (green)', 'empty (red)', 'empty (white)', 'WALK (green)', 'WALK (red)', 'WALK (white)', 'WILL STOP (green)', 'WILL STOP (red)', 'WILL STOP (white)', 'WON''T STOP (green)', 'WON''T STOP (red)', 'WON''T STOP (white)'},'Fontsize',24,'Fontname','Arial')
title(['Before filtering (N = ' num2str(size(X,1)) ')'], 'Fontsize',20)
ylim([0 NUMBER_PARTICIPANTS])
xtickangle(45)

subplot(1,3,2); % after filering
b=bar([sum(X_filtered(:,27:41)==1); sum(X_filtered(:,27:41)==2); sum(X_filtered(:,27:41)==-1)]', 'stacked');
b(1).FaceColor=[0 195 255]/255;
b(2).FaceColor=[255 165 0]/255;
b(3).FaceColor=[200 200 200]/255;
legend('Yes', 'No', 'Not sure', 'Location', 'southeast')
set(gca,'xticklabel',{'DON''T WALK (green)', 'DON''T WALK (red)', 'DON''T WALK (white)', 'empty (green)', 'empty (red)', 'empty (white)', 'WALK (green)', 'WALK (red)', 'WALK (white)', 'WILL STOP (green)', 'WILL STOP (red)', 'WILL STOP (white)', 'WON''T STOP (green)', 'WON''T STOP (red)', 'WON''T STOP (white)'},'Fontsize',24,'Fontname','Arial')
title([num2str(THRESHOLD_COLOR) ' wrong answers allowed (N = ' num2str(size(X_filtered,1)) ')'],'Fontsize',20)
ylim([0 size(X_filtered,1)])
xtickangle(45)

subplot(1,3,3); % after filering with strict creteria
Z_strict = Z;

invalid3 = find(sum(Z_strict(:,1:15),2)<NUMBER_CONCEPTS);
invalid = unique([invalid1;invalid2;invalid3]); % Add together all invalid rows with data
X_filtered_strict = X; % copy data before filtering
X_filtered_strict(invalid,:)=[]; % Remove invalid respondents
b=bar([sum(X_filtered_strict(:,27:41)==1); sum(X_filtered_strict(:,27:41)==2); sum(X_filtered_strict(:,27:41)==-1)]', 'stacked');
b(1).FaceColor=[0 195 255]/255;
b(2).FaceColor=[255 165 0]/255;
b(3).FaceColor=[200 200 200]/255;
legend('Yes', 'No', 'Not sure', 'Location', 'southeast')
set(gca,'xticklabel',{'DON''T WALK (green)', 'DON''T WALK (red)', 'DON''T WALK (white)', 'empty (green)', 'empty (red)', 'empty (white)', 'WALK (green)', 'WALK (red)', 'WALK (white)', 'WILL STOP (green)', 'WILL STOP (red)', 'WILL STOP (white)', 'WON''T STOP (green)', 'WON''T STOP (red)', 'WON''T STOP (white)'},'Fontsize',24,'Fontname','Arial')
title(['No wrong answers allowed (N = ' num2str(size(X_filtered_strict,1)) ')'],'Fontsize',20)
ylim([0 size(X_filtered_strict,1)])
xtickangle(45)
h=findobj('FontName','Arial'); set(h,'FontSize',14)
%% Figure 6. Distribution of answers to the question What is the color of the text/pixels on the display of the car above? before filtering of data.
figure;
temp=[sum(X(:,42:56)==1); sum(X(:,42:56)==2); sum(X(:,42:56)==3); sum(X(:,42:56)==-1)]';
temp2=[zeros(size(temp,1),1) cumsum(temp')'];
b=bar(temp, 'stacked','linewidth',2);
legend('Green', 'Red', 'White', 'Not sure','location','northoutside','orientation','horizontal')
b(1).FaceColor=[204 255 204]/255;
b(2).FaceColor=[255 102 102]/255;
b(3).FaceColor=[255 255 255]/255;
b(4).FaceColor=[200 200 200]/255;
for i2=1:4
    for i=1:15
        text(i,(temp2(i,i2)+temp2(i,i2+1))/2,num2str(temp(i,i2)),'horizontalalignment','center','fontsize',10)
    end
end
ylabel('Number of respondents')
set(gca,'xticklabel',{'DON''T WALK (green)', 'DON''T WALK (red)', 'DON''T WALK (white)', 'empty (green)', 'empty (red)', 'empty (white)', 'WALK (green)', 'WALK (red)', 'WALK (white)', 'WILL STOP (green)', 'WILL STOP (red)', 'WILL STOP (white)', 'WON''T STOP (green)', 'WON''T STOP (red)', 'WON''T STOP (white)'},'Fontsize',24,'Fontname','Arial')
xtickangle(45)
set(gca,'xlim',[0.4 15.6],'TickDir','out','ticklength',[0.005 0.005],'LooseInset',[0.01 0.01 0.01 0.01])
h=findobj('FontName','Helvetica'); set(h,'FontSize',16,'Fontname','Arial')
%% Spearman''s correlation coefficients
% 1 = Instructions understood
% 2 = Gender
% 3 = Age
% 8-14 = DBQ
X_corr = X_filtered;
for i=1:length(X_corr)
    if (X_corr == 1)
    end
end
CrossScore=nanmean(changem(X_filtered(:,27:41),[0 0.5 1],[2 -1 1]),2); % 1 = Yes, 2 = No, -1 = Unsure
Trust=nanmean([X_filtered(:,[17:20 22:25]) 6-X_filtered(:,21)],2);
temp=[CrossScore X_filtered(:,[2 3]) nanmean(X_filtered(:,[10 11]),2) nanmean(X_filtered(:,[9 12:15]),2) Trust X_filtered(:,[6:8 57])]; % Gender, Age, Speeding violations, Non-speeding violations

[c,p,clow,chigh]=corrcoef(tiedrank(temp),'rows','pairwise');
c=c(2:end,1);clow=clow(2:end,1);chigh=chigh(2:end,1);p=p(2:end,1);
figure;hold on
barh(c,'facecolor',[0 144 189]/255);
for i=1:length(c)
    plot([chigh(i) chigh(i)],[i-0.15 i+.15],'k','linewidth',1)
    plot([clow(i) clow(i)],[i-0.15 i+.15],'k','linewidth',1)
    plot([clow(i) chigh(i)],[i i],'k','linewidth',1)
end
box on
set(gca,'ytick',1:9,'yticklabel',{'Gender (1 = female, 2 = male)','Age (years)','Speeding violations score','Non-speeding violations score','Trust score','Driving frequency','Mileage','Number of accidents','Survey completion time'},'ydir','reverse','xlim',[-0.3 0.3],'ylim',[.2 9.8])
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',20)
xlabel('Spearman''s correlation coefficient')
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',20)
set(gca,'LooseInset', [0.01 0.01 0.01 0.01],'xlim',[-0.2 0.2]);
%% Bar graph
[~, ~, ub] = unique(Country_filtered);
test2counts = histcounts(ub, 'BinMethod','integers');
[B,I] = maxk(test2counts,10);
country_unique = unique(Country_filtered);
disp('Most common countries (after filtering) = ')
disp(country_unique(I))
disp(B)

temp=NaN(length(country_unique(I)),15,3);
for i=1:length(country_unique(I))
    temp(i,:,:)=[sum(X_filtered(strcmp(Country_filtered, country_unique(I(i))),27:41)==1); sum(X_filtered(strcmp(Country_filtered,country_unique(I(i))),27:41)==2); sum(X_filtered(strcmp(Country_filtered,country_unique(I(i))),27:41)==-1)]';
end

opengl hardware

temp=[sum(X_filtered(:,27:41)==1); sum(X_filtered(:,27:41)==2); sum(X_filtered(:,27:41)==-1)]';

temp_VEN=[sum(X_filtered(strcmp(Country_filtered,'VEN'),27:41)==1); sum(X_filtered(strcmp(Country_filtered,'VEN'),27:41)==2); sum(X_filtered(strcmp(Country_filtered,'VEN'),27:41)==-1)]';
temp_IND=[sum(X_filtered(strcmp(Country_filtered,'IND'),27:41)==1); sum(X_filtered(strcmp(Country_filtered,'IND'),27:41)==2); sum(X_filtered(strcmp(Country_filtered,'IND'),27:41)==-1)]';
temp_USA=[sum(X_filtered(strcmp(Country_filtered,'USA'),27:41)==1); sum(X_filtered(strcmp(Country_filtered,'USA'),27:41)==2); sum(X_filtered(strcmp(Country_filtered,'USA'),27:41)==-1)]';
temp_UKR=[sum(X_filtered(strcmp(Country_filtered,'UKR'),27:41)==1); sum(X_filtered(strcmp(Country_filtered,'UKR'),27:41)==2); sum(X_filtered(strcmp(Country_filtered,'UKR'),27:41)==-1)]';

temp_VEN=100*temp_VEN./repmat(sum(temp_VEN,2),1,3);
temp_IND=100*temp_IND./repmat(sum(temp_IND,2),1,3);
temp_USA=100*temp_USA./repmat(sum(temp_USA,2),1,3);
temp_UKR=100*temp_UKR./repmat(sum(temp_UKR,2),1,3);

figure;hold on
subplot(1,3,1);
plot(temp_VEN(1,1),temp_IND(1,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16);hold on % green
plot(temp_VEN(2,1),temp_IND(2,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16) % red
plot(temp_VEN(3,1),temp_IND(3,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(4,1),temp_IND(4,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(5,1),temp_IND(5,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(6,1),temp_IND(6,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(7,1),temp_IND(7,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(8,1),temp_IND(8,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(9,1),temp_IND(9,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(10,1),temp_IND(10,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(11,1),temp_IND(11,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(12,1),temp_IND(12,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(13,1),temp_IND(13,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(14,1),temp_IND(14,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(15,1),temp_IND(15,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
text(4,95,['\itr\rm = ' sprintf('%0.2f',corr(temp_VEN(:,1),temp_IND(:,1)))])
plot([0 100],[0 100],'k--')
xlabel('Percentage ''yes'' for respondents from Venezuela')
ylabel('Percentage ''yes'' for respondents from India')
axis equal
set(gca,'xlim',[0 100],'ylim',[0 100],'TickDir','out','ticklength',[0.005 0.005],'LooseInset',[0.01 0.01 0.01 0.01])

subplot(1,3,2)
plot(temp_VEN(1,1),temp_USA(1,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16);hold on % green
plot(temp_VEN(2,1),temp_USA(2,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16) % red
plot(temp_VEN(3,1),temp_USA(3,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(4,1),temp_USA(4,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(5,1),temp_USA(5,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(6,1),temp_USA(6,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(7,1),temp_USA(7,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(8,1),temp_USA(8,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(9,1),temp_USA(9,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(10,1),temp_USA(10,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(11,1),temp_USA(11,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(12,1),temp_USA(12,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(13,1),temp_USA(13,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(14,1),temp_USA(14,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(15,1),temp_USA(15,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
text(4,95,['\itr\rm = ' sprintf('%0.2f',corr(temp_VEN(:,1),temp_USA(:,1)))])
plot([0 100],[0 100],'k--')
xlabel('Percentage ''yes'' for respondents from Venezuela')
ylabel('Percentage ''yes'' for respondents from USA')
axis equal
set(gca,'xlim',[0 100],'ylim',[0 100],'TickDir','out','ticklength',[0.005 0.005],'LooseInset',[0.01 0.01 0.01 0.01])

subplot(1,3,3)
plot(temp_VEN(1,1),temp_UKR(1,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16);hold on % green
plot(temp_VEN(2,1),temp_UKR(2,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16) % red
plot(temp_VEN(3,1),temp_UKR(3,1),'s','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(4,1),temp_UKR(4,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(5,1),temp_UKR(5,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(6,1),temp_UKR(6,1),'o','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(7,1),temp_UKR(7,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(8,1),temp_UKR(8,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(9,1),temp_UKR(9,1),'d','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(10,1),temp_UKR(10,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(11,1),temp_UKR(11,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(12,1),temp_UKR(12,1),'p','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
plot(temp_VEN(13,1),temp_UKR(13,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[204 255 204]/255,'markersize',16)
plot(temp_VEN(14,1),temp_UKR(14,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 102 102]/255,'markersize',16)
plot(temp_VEN(15,1),temp_UKR(15,1),'h','linewidth',1,'markeredgecolor','k','markerfacecolor',[255 255 255]/255,'markersize',16) % white
text(4,95,['\itr\rm = ' sprintf('%0.2f',corr(temp_VEN(:,1),temp_UKR(:,1)))])
plot([0 100],[0 100],'k--')
xlabel('Percentage ''yes'' for respondents from Venezuela')
ylabel('Percentage ''yes'' for respondents from Ukraine')
axis equal
set(gca,'xlim',[0 100],'ylim',[0 100],'TickDir','out','ticklength',[0.005 0.005],'LooseInset',[0.01 0.01 0.01 0.01])
h=findobj('FontName','Helvetica'); set(h,'FontSize',12,'Fontname','Arial')
legend1=legend(gca,{'DON''T WALK','empty','WALK','WILL STOP','WON''T STOP'},'Orientation','horizontal','color','none');
set(legend1,'Position',[0.37 0.75 0.30 0.02],'fontsize',16)
legend boxoff
